﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2011.06.22.
 * Idő: 11:50
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Drawing;
using System.Windows.Forms;

namespace TetheredSun.Controls
{
	/// <summary>
	/// Description of AxisBoundsEditor.
	/// </summary>
	public partial class AxisBoundsEditor : Form
	{
		protected double minimum;
		protected double maximum;
		protected bool autoscaled;
		protected bool suppressEvents = false;
		protected string numberFormat = "F2";
		
		public AxisBoundsEditor()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		public AxisBoundsEditor(double minimum, double maximum, bool autoscaled) : this()
		{
			this.Minimum = minimum;
			this.Maximum = maximum;
			this.Autoscaled = autoscaled;
		}
		
		public double Minimum {
			get { return minimum; }
			set {
				minimum = value;
				suppressEvents = true;
				textBox1.Text = minimum.ToString(numberFormat);
				suppressEvents = false;
			}
		}
		
		public double Maximum {
			get { return maximum; }
			set { 
				maximum = value;
				suppressEvents = true;
				textBox2.Text = maximum.ToString(numberFormat);
				suppressEvents = false;
			}
		}
		
		public string NumberFormat {
			get { return numberFormat; }
			set { numberFormat = value; }
		}
		
		
		public bool Autoscaled {
			get { return autoscaled; }
			set { 
				autoscaled = value;
				suppressEvents = true;
				checkBox.Checked = autoscaled;
				textBox1.Enabled = !autoscaled;
				textBox2.Enabled = !autoscaled;
				suppressEvents = false;
			}
		}
		
		protected void HandleButtonClickEvents(object sender, EventArgs e)
		{
			if (sender == okButton) {
				this.DialogResult = DialogResult.OK;
			} else {
				this.DialogResult = DialogResult.Cancel;
			}
			
			this.Close();
		}
		
		protected void HandleCheckedChangedEvents(object sender, EventArgs e)
		{
			if (suppressEvents) return;
			
			if (sender == checkBox) {
				autoscaled = checkBox.Checked;
				textBox1.Enabled = !autoscaled;
				textBox2.Enabled = !autoscaled;
			}
		}
		
		protected void HandleTextChangedEvents(object sender, EventArgs e)
		{
			if (suppressEvents) return;
			
			TextBox textBox = sender as TextBox;
			double parsed;
			bool successful;
			
			if (textBox == null) {
				return;
			}
			
			successful = Double.TryParse(textBox.Text, out parsed);
			
			if (successful) {
				if (textBox == textBox1) {
					minimum = parsed;
				} else if (textBox == textBox2) {
					maximum = parsed;
				}
			}
		}
		
		
	}
}
