/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.04.14.
 * Time: 11:18
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
//
using TetheredSun;

namespace TetheredSun.Controls
{
	/// <summary>
	/// Description of Curve.
	/// </summary>
	public class Curve
	{
		protected Pen line = new Pen(Color.DarkSeaGreen, 2.0f);
		protected IDataPointList points;
		protected string label = null;
		protected bool visible = true;
		protected bool includeInAutoscaling = true;
		protected Symbol symbol = null;
		protected ErrorBar errorBar = null;
		
		public Curve(int capacity)
		{
			points = new SlimDataPointList(capacity);
		}
		
		public Curve() : this(SlimDataPointList.DefaultCapacity) { }
		
		
		public ErrorBar ErrorBar {
			get { return errorBar; }
			set { errorBar = value; }
		}
		
		public bool HasLine {
			get { return (line != null) && (line.Width > 0); }
		}
		
		public bool IncludeInAutoscaling {
			get { return includeInAutoscaling; }
			set { includeInAutoscaling = value; }
		}
		
		public Pen Line {
			get { return line; }
		}
		
		public IDataPointList Points {
			get { return points; }
			set { points = value; }
		}
		
		public string Label {
			get { return label; }
			set { label = value; }
		}
		
		public bool Visible {
			get { return visible; }
			set { visible = value; }
		}
		
		public Symbol Symbol {
			get { return symbol; }
			set { symbol = value; }
		}
		
		
	}
}
