﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.08.17.
 * Time: 11:54
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;

namespace TetheredSun.Mathematics
{
	/// <summary>
	/// A bin of a histogram.
	/// </summary>
	public class Bin
 	{
 		protected double min;
 		protected double width;
 		protected int count = 0;
 		
		public Bin(double min, double width)
		{
			this.min = min;
			this.width = width;
		}
		
		public Bin(double min)
		{
			this.min = min;
		}
		
		public double Min {
			get { return min; }
		}
 		
		public double Width {
			get { return width; }
		}
 		
		public int Count {
			get { return count; }
		}
		
		public void Reset()
		{
			count = 0;
		}
		
		public static Bin operator++(Bin bin)
		{
			bin.count++;
			return bin;
		}
		
		public static Bin operator--(Bin bin)
		{
			bin.count--;
			if (bin.count < 0) bin.count = 0;
			return bin;
		}
 	}
}
