﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.08.24.
 * Time: 8:58
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;

namespace TetheredSun.Mathematics
{
	public static class NumericEquationSolver
	{
		public static double Precision = 0.0001;
		public static int MaximumIterations = 1000000000;
		
		public delegate double LeftSide(double[] parameters);
		
		public static double SolveBySecant(LeftSide leftSide, double[] parameters, int variableIndex, double initialGuess0, double initialGuess1)
		{
			double xn = Double.NaN;
			double xn1 = initialGuess1;
			double xn2 = initialGuess0;
			double yn1;
			double yn2;
			int iteration = 0;
			bool go = true;
			
			while (go) {
				parameters[variableIndex] = xn2;
				yn2 = leftSide(parameters);
				parameters[variableIndex] = xn1;
				yn1 = leftSide(parameters);
				xn = xn1 - yn1 * (xn1 - xn2) / (yn1 - yn2);
				go = (iteration < MaximumIterations) && (Math.Abs(xn - xn1) > Precision);
				//
				iteration++;
				xn2 = xn1;
				xn1 = xn;
			}
			
			return xn;
		}
	}
}
