﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.12.30.
 * Time: 14:50
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
//
using TetheredSun.Mathematics;

namespace TetheredSun.Medical
{
	/// <summary>
	/// Description of IntervalMean.
	/// </summary>
	public class Pnn50 : SuccessiveDifferenceParameter
	{
		public Pnn50()
		{
			this.unit = "%";
			this.name = "PNN50 (percentage of successive differences longer than 50 ms)";
			this.value = Double.NaN;
		}
		
		
		public override double Evaluate(IList<double> intervals)
		{
			double limit = (unit == "ms") ? 50.0 : 0.05;
			double pnn = 0;
			
			for (int i = 0; i < intervals.Count; i++) {
				if (intervals[i] > limit) pnn++;
			}
			
			value = pnn / intervals.Count * 100.0;
			
			return value;
		}
	}
}
